/****************************************Copyright (c)**************************************************
**                                      TXRFID
**                                    
**                                 http://www.txrfid.com
**
**--------------ļϢ-------------------------------------------------------------------------
**      : MUR500USB.H  
**      : TXRFID
**    : 200915
**        : ̬ͷļ
**
**-----------------޸ļ¼--------------------------------------------------------------
** ޸:    1.
** ǰ汾:    v1.00 
**   :    TXRFID
** ޸:    20090105
** ע    : 
**---------------------------------------------------------------------------------------

****************************************************************************************/
#ifndef __MUR500_OLD_H__
#define __MUR500_OLD_H__


#define MF1_S50                 0x04               
#define MF1_S70                 0x02
#define MF0_ULIGHT              0x44
#define MF1_LIGHT               0x10 

// PICC 
#define IDLE                    0x00
#define ALL                     0x01
#define ANTICOLLISION1          0x93       // anticollision level 1
#define ANTICOLLISION2          0x95       // anticollision level 2
#define ANTICOLLISION3          0x97       // anticollision level 3 
#define KEYA                    0x00       //ܳA
#define KEYB                    0x04       //ܳB
#define DECREMENT               0xC0
#define INCREMENT               0xC1
#define RESTORE                 0xC2

#define FALSE                   0
#define TRUE                    1
    
//ݿʽλ
#define SEQNR                    0          //ݽ
#define COMMAND	                 1          //ַ	
#define STATUS                   1          //״ַ̬
#define LENGTH                   2          //ݵĳ		
#define DATA                     3          //ֽ

//mifare error
#define OK                      0          //óɹ
#define NO_TAG_ERR              -1          //Чûп
#define CRC_ERR                 -2          //ӿнյ˴CRCУ
#define EMPTY                   -3          //ֵ
#define AUTH_ERR                -4          //֤
#define PARITY_ERR              -5          //ӿнյ˴Уλ
#define CODE_ERR                -6          //ͨŴ


#define SERNR_ERR               -8          //ڷͻʱ˴Ĵ
#define KEY_ERR                 -9          //֤ʵ*****
#define NOT_AUTH_ERR            -10         //û֤
#define BIT_COUNT_ERR           -11         //ӿнյ˴λ
#define BYTE_COUNT_ERR          -12         //ӿн˴ֽ
#define TRANS_ERR               -14         //Transfer
#define WRITE_ERR               -15         //Write
#define INCR_ERR                -16         //Increment
#define DECR_ERR                -17         //Decrment
#define READ_ERR                -18         //Read
#define COLL_ERR                -24         //ͻ
#define ACCESS_TIMEOUT          -27         //ʳʱ
#define QUIT	                -30         //һʱ
#define INVALID_PARA 31  // Ч
//check write Error
#define CHK_WR_OK               0          //Check Writeȷ
#define CHK_WR_FAILED           -1          //Check Write
#define CHK_WR_COMP_ERR         -2          //Check Write:дȽϳ


#define COMM_ERR		255	//ͨŴ

#ifdef __cplusplus
	extern "C" { 
#endif


/*********************************************************************************************************
** : MUR500USBʼ
**
** 䡡:          
**
** 䡡:  
**
** : OKQUITCOMM_ERR
**          
********************************************************************************************************/
unsigned char  __stdcall MUR500USB_Init();

/*********************************************************************************************************
** : MUR500ĸλ
**
** 䡡:          
**
** 䡡:  
**
** : OKQUITCOMM_ERR
**          
********************************************************************************************************/
unsigned char  __stdcall MUR500USB_Reset();

/*********************************************************************************************************
** : ȡ̬汾š
**
** 䡡:            
**
** 䡡:  汾
**
** : 
**          
********************************************************************************************************/
void __stdcall TX_Get_Dll_Ver(char *ver);

/*********************************************************************************************************
** : ģгʼʼɹģϵָʾƽʱ߷زźţ
**           κν߸ӦĿɵõIDLE״̬ʹһԿвʱоƬȫĵĵ
**           ģϵģڲԶִгʼָʾƽϵûɲִиúֱӽ
**           úڲϵµ³ʼ
**
** 䡡:            
**
** 䡡:  
**
** : OKQUITCOMM_ERR
**          
********************************************************************************************************/
unsigned char __stdcall TX_Config(void);

/*********************************************************************************************************
** : ˺رTXģ飬ָʾϨ߲زźţģĵĵСڴ״̬ڣ
**           ģ鲻ʹáҪʹģ飬ҪTX_Config()TXģ½á
**
** 䡡:            
**
** 䡡:  
**
** : OKCOMM_ERR
********************************************************************************************************/
unsigned char __stdcall TX_Close(void);

/*********************************************************************************************************
** : ȡmur500豸Ϣ
**
** 䡡:            
**
** 䡡:  ģϢ*InfoInfoΪϢռ׵ַInfo[0]Info[4]Ϊģͱʶ
**          Ϊ0x30,0x88,0xf8,0x00,0xXXInfo[5]Info[8]ΪоƬкţInfo[9]Ϊ̼汾ţ
**          λΪ汾ŵȡֵ115λΪ汾ŵСȡֵ09
**
** : OKQUITCOMM_ERR
**          
********************************************************************************************************/
unsigned char __stdcall TX_Get_Info(unsigned char *info);

/*********************************************************************************************************
** : ˺ǽָ루*KeyװصģָĵطKey_SectorǸıMifare1 
**           롣ֻģвģ뿨֮ûݴ䡣
**           ģ16 015, ΪԿKey_SectorÿԿAԿB
**           ܹ32 롣װسɹ󣬿øԿMifare1 ֤
**           M1Ҳ16洢ΪSectorҪıMifare1 ڵԿԭ֤ͨ
**           ֱдTX_Write()дMifareĳʼԿΪ6FFHABԿһ
**
** 䡡:  KeyAB:Կͣ1ֽڣȡֵΪ0x00KEYAԿA0x04KEYBԿB
**          Key_SectorԿţ1ֽڣȡֵΧ015
**          *KeyҪװصԿ6ֽڣ
**                
** 䡡:  
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITAUTH_ERRCOMM_ERR
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
unsigned char __stdcall TX_Load_Key(unsigned char KeyAB,unsigned char Key_Sector,unsigned char *Key);

/*********************************************************************************************************
** : TXģЧΧǷпڡѡһµĿʱøú
**           ƬܻӶõ縴λIDLEģ飬TX_Request
**           ALLIDLEһģʽ󣬿ƬӦؿƬͺTagType2ֽڣ
**           ĳһſɹ˹TX_HaltƬHalt״̬ʱĿֻ
**           ӦALLģʽ󣬳Ǹÿ뿪Ȼ½롣
**           TXģ鷢0x41󿨡
**           ע⣺ͬһſHALT״̬ʱһγɹһʧ
**
** 䡡: ReqModeģʽ ReqModeȡֵΪ10 
**                ReqMode0߷ΧIDLE״̬ĿHALT״̬ĳ⣩
**                ReqMode1߷Χڵп
**
** 䡡: TagType2ֽڵĿƬͣ*TagTypeֽ *(TagType+1)ֽڣ
**                    mifare 1Ϊ0x0004,*TagType  0x04 *(TagType+1)0x00
**                    ʱκݣLen=0
//
//                +----+----+----+----+----+----+----+----+       +----+----+----+----+----+----+----+----+
//        MSByte  | b7 | b6 | b5 | b4 | b3 | b2 | b1 | b0 |LSByte | b7 | b6 | b5 | b4 | b3 | b2 | b1 | b0 |
//                +----+----+----+----+----+----+----+----+       +----+----+----+----+----+----+----+----+
//                |                 RFU                   |       |                                       | 
//                                                                | UID size| RFU|   bit-frame anticoll   |
//                                                                |         |    |                        |
//                                                                | 00..std |    |  (if any bit set .. Y, | 
//                                                                | 01..dbl |    |             else .. N) |
//                                                                | 10..tpl |    |                        |
//Mifare 1 S50    |                 RFU                   |       |  0   0    0    0  | 0    1    0    0  |  = 0x0004   UID(Ψһкţ4ֽ ֡ͻʽ
//Mifare 1 S70    |                 RFU                   |       |  0   0    0    0  | 0    0    1    0  |  = 0x0002   UID(Ψһкţ4ֽ ֡ͻʽ
//Mifare UltraLight|                RFU                   |       |  0   1    0    0  | 0    1    0    0  |  = 0x0044   UID(Ψһкţ7ֽ ֡ͻʽײ
//Mifare Light    |                 RFU                   |       |  0   0    0    1  | 0    0    0    0  |  = 0x0010   UID(Ψһкţ4ֽ ֡ͻʽ
//SHC1101         |                 RFU                   |       |  0   0    0    0  | 0    1    0    0  |  = 0x0004   UID(Ψһкţ4ֽ ֡ͻʽ
//SHC1102         | 0    0    1    1  |  0    0    1    1 |       |  0   0    0    0  | 0    0    0    0  |  = 0x3300   UID(Ψһкţ4ֽ Ǳ֡ͻʽ               
//11RF32          |                 RFU                   |       |  0   0    0    0  | 0    1    0    0  |  = 0x0004   UID(Ψһкţ4ֽ ֡ͻʽ
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRBIT_COUNT_ERRCOMM_ERR
**
********************************************************************************************************/
unsigned char __stdcall TX_Request(unsigned char ReqMode,unsigned short &tagtype);


/*********************************************************************************************************
** : ѡķײúڵTX_RequestáƬλʱ
**           ִкܵõкǸƬке4ֽڡ
**           кų֣4ֽڡ7ֽں10ֽڡ4ֽڵֻҪһײɵõкţ
**           Mifare1 S50 S70ȣ7ֽڵҪжײܵõкţǰһõкŵ
**           ֽΪ־0x88кֻ3ֽڿãһײܵõ4ֽкţ߰˳
**           ӼΪ7ֽкţUltraLightDesFireȣ10ֽڵԴƣûд࿨
**           Ҫжײͨ޸ĲSelect_Codeʵ֡һʹSelect_Code0x93
**           ڶʹSelect_Code0x95,еMifareҪײΪMifareк
**           Ϊ7ֽڡ֪Ҫѡ񿨵кź󣬾ûбҪִиTX_AntiCollʱTX_Request
**           ֱӵTX_Selectɡ
**           
** 䡡:  Select_Codeײ㼶룺һ㣨ANTICOLL10x93㣨ANTICOLL20x95㣨ANTICOLL30x97
	    BcntԤѡѾ֪кŵĵλͨBcnt=0 
**      
** 䡡: *SNR4ֽڵĿкţֽڷڵ͵ַ*SNRֽ *(SNR+i)ֽ
**                кų4ֽڣMifare UltraLightкŲֽ
**                ֵΪ0x88ʾҪиһķײ0x95
**
** : TXģִи״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRBIT_COUNT_ERRCOMM_ERR
**
********************************************************************************************************/
unsigned char __stdcall TX_Casc_Anticoll(unsigned char bcnt,unsigned char code,
											  unsigned long &snr);
/*********************************************************************************************************
** : úѡĳһкŵĿ֮ͨӣǷѡɹӦ*Sak
**           úһTX_Casc_Anticoll()ʹãж༶ײ󿨵ѡ
**           Select_CodeʾײļӦúִǰTX_Casc_Anticoll()еSelect_Codeͬ.
**           һײɹִк󣬻κʱ򵱳Աʵʵ֪кŵĿƬͨʱ
**           ʹTX_Casc_SelectTX_SelectԽѡͨš
**           кų֣4ֽڡ7ֽں10ֽڡ4ֽڵֻҪһѡ񼴿,Mifare1 S50 S70ȣ
**           7ֽڵҪöѡɣUltraLightDesFireȡҪжѡ񣬵һѡ
**           кΪһײõк,ֽΪ־0x88ֻ3ֽڿãڶѡ
**           кΪڶײõ4ֽкš
**           ڳп*Sakbit2λжǷкδif(*SAK & 0x04){}
**
** 䡡:  Select_Codeײ㼶룺һ㣨ANTICOLL10x93㣨ANTICOLL20x95㣨ANTICOLL30x97
**                        òӦ֮ǰCasc_Anticoll()еSelect_Codeͬ
**          *SNRǰһηײصĿš޷4ֽڣֽڷڵ͵ַ 
**                 źŴ4ֽڣ*SNRֵֽΪ0x88ʾҪиһķײ
** 䡡: *SakǷѡɹӦ,£
**
//                +----+----+----+----+----+----+----+----+
//       *Sak     | b7 | b6 | b5 | b4 | b3 | b2 | b1 | b0 |
//                +----+----+----+----+----+----+----+----+
//                |   RFU   |diff|   RFU   | ok |   RFU   | 
//Mifare 1 S50    |  0   0    0    0  |  1    0    0   0  |  = 0x08   
//Mifare 1 S70    |  0   0    0    1  |  1    0    0   0  |  = 0x18 
//Mifare UltraLight| 0   0    0    0  |  0    1    0   0  |  = 0x04 1ѡ
//Mifare Light    |  0   0    0    0  |  0    0    0   1  |  = 0x01 
//SHC1101         |  0   0    1    0  |  0    0    1   0  |  = 0x22 
//11RF32          |  0   0    0    0  |  1    0    0   0  |  = 0x08 
**
// bit2λжǷкδbit20ʱʾкϣѡɹ
// bit21ʱʾкûȫ룬ѡûȫɹҪһķײѡ
//	xxxxx1xx: źûɣҪһķײѡ
//	xx1xx0xx: ѡɹÿISO/IEC 14443-4׼
//	xx0xx0xx: ѡɹÿISO/IEC 14443-4׼
**
** : TXģִ״̬
**           ܵ״ֵ̬£OK, QUIT, NO_TAG_ERR, CRC_ERR, PARITY_ERR, BIT_COUNT_ERR,COMM_ERR
**
*********************************************************************************************************/
unsigned char __stdcall TX_Casc_Select(unsigned char Select_Code,unsigned long snr,unsigned char &sak);

/*********************************************************************************************************
** : ʹģڲԿKey_SectorеָĿSector֤Sectorе
**           洢ģKey_Sectorе֤ͬɹOKTX_Authͬǣúͬʱ
**           SectorKey_SectorģеԿͿеǽĹϵҸúָSector
**           ģڲKey_SectorSectorȡֵΧΪ039S70֤ʵ
**           TX_AuthһúҲTX_Load_KeyɹִйΪģڲKey_Sectorе
**           ҪTX_Load_Keyװءúڶп˵ͬӦãԿװؿһȫ
**           һװ롣
**
** 䡡: KeyAB=KEYA(0x00),ԿA֤ 
**                =KEYB(0x04),ԿB֤
**         SectorҪ֤ĿţҲҪʵĿţȡֵΧ039S70
**         Key_Sector: ֤ʵģܳţȡֵΧ015
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRPARITY_ERRBIT_COUNT_ERRCOMM_ERR
**
********************************************************************************************************/
unsigned char __stdcall TX_Auth2(unsigned char KeyAB,unsigned char Sector,unsigned char Key_Sector);



/*********************************************************************************************************
** : Կ֤;ڶԿждӡȲǰԿ֤
**           еԿƥ䡣֤ʵɹOK
**           ֤Կλ*Keyָָ6ֽڴ洢ڣִʱԿв˱Ϊֱ֤ʵ
**           ֱ֤ʵһڶÿһſ˵ԿͬӦãʹðȫģ飨PSAMӦУ
**           ѻȽкŶȻPSAMԿһɵԿȻֱõԿ뿨һӦ໥֤ʵ
**
** 䡡: KeyAB=KEYA(0x00),ԿA֤ 
**                =KEYB(0x04),ԿB֤
**         Key:   ֤ʵַ,Ӧⲿһ6ֽڵڴ롣
**         SectorҪ֤ĿţҲҪʵĿţȡֵΧ039S70
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRAUTH_ERR, PARITY_ERRBIT_COUNT_ERRCOMM_ERR
**
********************************************************************************************************/
unsigned char __stdcall TX_Auth_Key(unsigned char KeyAB,unsigned char *key,unsigned char Sector);


/*********************************************************************************************************
** : ˺еshc1102бȽϣƥMI_OK
**
** 䡡: KeyBlockԿַSHC1102Ϊ8
           Key֤ʵ׵ַ,Ӧⲿһ4ֽڵڴ

** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRAUTH_ERR, PARITY_ERRBIT_COUNT_ERRCOMM_ERR
**
********************************************************************************************************/
unsigned char __stdcall TX_Shc1102_Auth(unsigned char keyblock,unsigned char *key);

/*********************************************************************************************************
** : ֤ɹʹøúMifareӦݡMifareһ16ֽڣ˶д
**           һξ16ֽڡű֮ǰ֤Ŀͬһڣmifare1ӿ0ʼ˳
**           ÿ41
**           ΪMifareÿܲͬҪһſеĶвڶĳһ
**           Ϻ󣬱һܶһֱӽ֤ʼ
**           ݲܱȡ                   
**
** 䡡: Blockţ1ֽڣ	S50063S700255
**
** 䡡: *DataDataΪ16ֽݵ׵ַ
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Read_Enc(unsigned char Block,unsigned char *data);

/*********************************************************************************************************
** : SHC1102Ӧݡ                   
**
** 䡡: Blockţ1ֽڣ
**
** 䡡: *DataDataΪ4ֽݵ׵ַ
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Shc1102_Read(unsigned char block,unsigned char* data);

/*********************************************************************************************************
** : mifare lightӦݡ                   
**
** 䡡: Blockţ1ֽڣ
**
** 䡡: *DataDataΪ4ֽݵ׵ַ
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_ML_Read(unsigned char Block,unsigned char *data);

/*********************************************************************************************************
** :ĳһֵ顣
**
** 䡡:  
   Block--ţ1ֽڣ			S501~63
									S701~255 
**                
** 䡡:  valueΪ4ֽݡ
**
** : TXģִ״̬
**           ܵ״ֵ̬£OK, MI_WRONG_VALUE, NO_TAG_ERR, BIT_COUNT_ERR, TRANS_ERR, CODE_ERR, COMM_RERR
**           
********************************************************************************************************/
unsigned char __stdcall TX_Read_Val(unsigned char Block,long &value);


/*********************************************************************************************************
** : Կĳһ֤ɹ󣬼ɶͬһĸдֻҪ
**           аλβ飬ǸΨһ                   
**
** 䡡: Blockţ1ֽڣ	S50163S701255  0鲻д
**         *Data16ָֽ룬DataΪд16ֽݵ׵ַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Write_Enc(unsigned char Block,unsigned char *data);




/*********************************************************************************************************
** : UltraLightдһ4ֽڵݡֻUltraLightЧUltraLightжmifare1һ                   
**           
** 䡡: Blockţ1ֽڣ115 0鲻д
**         *Data4ָֽ룬DataΪд4ֽݵ׵ַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
*********************************************************************************************************/
unsigned char __stdcall TX_ULwrite_Enc(unsigned char Block,unsigned char *Data);


/*********************************************************************************************************
** : SHC1102ָдֽݡ                   
**
** 䡡: Blockţ1ֽڣ	
**         *Data4ָֽ룬DataΪд4ֽݵ׵ַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Shc1102_Write(unsigned char Block,unsigned char* data);

/*********************************************************************************************************
** : Mifare lightָдֽݡ                   
**
** 䡡: Blockţ1ֽڣ	
**         *Data4ָֽ룬DataΪд4ֽݵ׵ַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITNO_TAG_ERRCRC_ERRNOT_AUTH_ERRPARITY_ERRBIT_COUNT_ERR
**           COMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_ML_Write(unsigned char Block,unsigned char *data);
/*********************************************************************************************************
** : MifareӦдֵʽݡ
**
** 䡡: 
Block--ţ1ֽڣ			S501~63
									S701~255
Value     洢ֵֵлָʱֵΪֵValueǼֵֵ 
**                
** 䡡:  ޡ
**
** : TXģִ״̬
**           ܵ״ֵ̬£OK, QUIT, NO_TAG_ERR, BIT_COUNT_ERR, TRANS_ERR, CODE_ERR, COMM_RERR
**           
********************************************************************************************************/
unsigned char __stdcall TX_Write_Val(unsigned char Block,long value);


/*********************************************************************************************************
** : ˺ִTX_Writeд뿨ȷԼ顣ú½
**           TX_RequestTX_SelectTX_AuthTX_Auth֤ܳʱõܳBlockڵͬ
**           ˺нݣ*DataӦBlockַݽбȽϡȷ򷵻
**           CHK_WR_OKϢ߼ݲ򷵻CHK_WR_COMP_ERRϢκδʱ
**           CHK_WR_FAILEDϢ  
**         
** 䡡: SNR  ҪĿ
**         KeyABһдʱ֤ģʽKeyABԿͣ1ֽڣ
**                ȡֵΪKeyAB0x00KEYAԿA֤KeyAB0x04KEYBԿB֤ԿB
**         BlockҪݿĵַS50063S700255
**         *Data16ָֽ룬 DataΪڶԱϴд16ֽݵĵ׵ַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£QUITCHK_WR_OKCHK_WR_FAILEDCHK_WR_COMP_ERRCOMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Check_Write(unsigned char snr,unsigned char KeyAB,unsigned char Block,unsigned char *data);

/*********************************************************************************************************
** : ˺ԿڵĳһмӡݱݣÿΪֵʽ֧Զ͡
**           úʵTX_IncrementTX_DecrementTX_RestoreTX_Transferϡ˿
**           ú滻봫ͬ򽫲ĽдԭĿڣ
**           봫Ųͬ򽫲Ľд봫ڣڵݱǣ
**           ԭڵֵ䡣ģʽΪָʱֵ塣     
**  
** 䡡: ValueMode0xC0 0xC1ӣ 0xC2ָ
**         BlockڿַԸÿֵȡֵΧS50063S700255
**         Value4ֽݣ洢ֵֵлָʱֵΪֵ
**                 ValueǼֵֵŵ׵ַʱ͵ַŸֽڡ
**         Trans_BlockַȡֵΧS50063S700255
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OK, QUIT, NO_TAG_ERR, BIT_COUNT_ERR, TRANS_ERR, CODE_ERR, COMM_RERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Value(unsigned char ValueMode,unsigned char Block,long &value,unsigned char Trans_Block);



/*********************************************************************************************************
** : ѡΪ״̬ҪѡӦALLģʽTX_Request
**           Ҫѡ,ҲԽ뿪߲ٽ룬ִиλTX_Reset()
**           ʹTX_Request()TX_Halt()һԿ۷ѣ翨ӦֻһΣһԪǮ
**           뿪´νٿһΣڸӦͣʱϳҲ۶һΡ
**
** 䡡: 
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITCOMM_ERR
**
********************************************************************************************************/
unsigned char __stdcall TX_Halt(void);


/*********************************************************************************************************
** : úʹģϵƵ·رգرյʱɲMsecָMsec=0Ƶ·һֱڹر״̬
**            һֱһTX_RequestرƵ·ʹڵпλ
**  
** 䡡: Msecȡֵ0~255ģƵ·رʱ䣨msΪλMsec0ʱһֱرա 
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITCOMM_ERRеĳһ
**
*******************************************************************************************************/
unsigned char __stdcall TX_Reset(unsigned char msec);


/*********************************************************************************************************
** : ˺ģEEPROMݶ         
**  
** 䡡: Adr   ģEEPROMַС0x80
**         Lengthݳ
**         *Data ָ룬DataΪݻַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITCRC_ERRBIT_COUNT_ERRCOMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Read_E2(unsigned char addr,unsigned char length,unsigned char *data);


/*********************************************************************************************************
** : ˺дģEEPROMСģEEPROM0x000x0FΪֻƷϢ0x100x2F
**           ΪĴʼļòҪд0x800x1FFΪֻԿTX_Load_Keyд롣
**           0x7FΪģ鲨ʲòҪд         
**  
** 䡡: Adr   дģEEPROMַȡֵΧ0x300x7E
**         Lengthдݳ
**         *Data ָ룬DataΪдݻַ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITCRC_ERRBIT_COUNT_ERRCOMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Write_E2(unsigned char addr,unsigned char length,unsigned char *data);




/*********************************************************************************************************
** : ˺̵Ϩ
**  
** 䡡:  
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITCOMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Green_Off();

/*********************************************************************************************************
** : ˺̵
**  
** 䡡:  
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKQUITCOMM_ERRеĳһ
**
********************************************************************************************************/
unsigned char __stdcall TX_Green_On();


/*********************************************************************************************************
** : ˺һ̵ƣƵʡʱ䡢϶ʱظ趨
**
** 䡡: Control:	 ֣Control = 0x01ʱƶΪControl = 0x02ʱƶΪ̵ƣ
           Control = 0x03ʱ̵ƺͷͬʱơ 
**             
**         OpenTime:	 ʱ䣬ȡֵ025510msķֱ
**         CloseTime:	 ϶ʱ䣬ȡֵ025510msķֱ
**         RepCnt:	 ظ
**
** 䡡: 
**
** : TXģִ״̬
**           ܵ״ֵ̬£OKCOMM_ERRеĳһ
**
*******************************************************************************************************/
unsigned char __stdcall TX_Alarm(unsigned char contrl,unsigned char opentm,unsigned char closetm,unsigned char repcnt);




/***************************************************************************/
/***************************************************************************/


///////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
  }
#endif

#endif  