/****************************************Copyright (c)**************************************************
**                                      TXRFID
**                                    
**                                 http://www.txrfid.com
**
**--------------ļϢ-------------------------------------------------------------------------
**      : MUR500USB.H  
**      : TXRFID
**    : 200915
**        : ̬ͷļ
**

  **-----------------޸ļ¼--------------------------------------------------------------
  ** ǰ汾:    v3.2 
  **   :    TXRFID
  ** ޸:    11.04.10
  ** ޸:    1. кTX2ͷ,  ĲͷֵͳһUINTַ, ӿ.

**-----------------޸ļ¼--------------------------------------------------------------
** ޸:    1.
** ǰ汾:    v1.00 
**   :    TXRFID
** ޸:    20090105
** ע    : 
**---------------------------------------------------------------------------------------

****************************************************************************************/
#ifndef __MUR500USB_H__
#define __MUR500USB_H__


#define MF1_S50                 0x04               
#define MF1_S70                 0x02
#define MF0_ULIGHT              0x44
#define MF1_LIGHT               0x10 

// PICC 
#define IDLE                    0x00
#define ALL                     0x01
#define ANTICOLLISION1          0x93       // anticollision level 1
#define ANTICOLLISION2          0x95       // anticollision level 2
#define ANTICOLLISION3          0x97       // anticollision level 3 
#define KEYA                    0x00       //ܳA
#define KEYB                    0x04       //ܳB
#define DECREMENT               0xC0
#define INCREMENT               0xC1
#define RESTORE                 0xC2

#define FALSE                   0
#define TRUE                    1
    
//ݿʽλ
#define SEQNR                    0          //ݽ
#define COMMAND	                 1          //ַ	
#define STATUS                   1          //״ַ̬
#define LENGTH                   2          //ݵĳ		
#define DATA                     3          //ֽ

//mifare error
#define OK                      0          //óɹ
#define NO_TAG_ERR              -1          //Чûп
#define CRC_ERR                 -2          //ӿнյ˴CRCУ
#define EMPTY                   -3          //ֵ
#define AUTH_ERR                -4          //֤
#define PARITY_ERR              -5          //ӿнյ˴Уλ
#define CODE_ERR                -6          //ͨŴ


#define SERNR_ERR               -8          //ڷͻʱ˴Ĵ
#define KEY_ERR                 -9          //֤ʵ*****
#define NOT_AUTH_ERR            -10         //û֤
#define BIT_COUNT_ERR           -11         //ӿнյ˴λ
#define BYTE_COUNT_ERR          -12         //ӿн˴ֽ
#define TRANS_ERR               -14         //Transfer
#define WRITE_ERR               -15         //Write
#define INCR_ERR                -16         //Increment
#define DECR_ERR                -17         //Decrment
#define READ_ERR                -18         //Read
#define COLL_ERR                -24         //ͻ
#define ACCESS_TIMEOUT          -27         //ʳʱ
#define QUIT	                -30         //һʱ
#define INVALID_PARA 31  // Ч
//check write Error
#define CHK_WR_OK               0          //Check Writeȷ
#define CHK_WR_FAILED           -1          //Check Write
#define CHK_WR_COMP_ERR         -2          //Check Write:дȽϳ


#define COMM_ERR		255	//ͨŴ

#ifdef __cplusplus
	extern "C" { 
#endif


/*********************************************************************************************************
** : MUR500USBʼ
**
** 䡡:          
**
** 䡡:  
**
** : μֵб
**          
********************************************************************************************************/
UINT  __stdcall TX2_Init();


/*********************************************************************************************************
** : ȡ̬汾š
**
** 䡡:            
**
** 䡡:  汾
**
** : μֵб
**          
********************************************************************************************************/
void __stdcall TX_Get_Dll_Ver(char *ver);


/*********************************************************************************************************
**   :  ˺ǽָװصMUR-500ָԿǸıMifare1 롣
**          ֻMUR-500вMUR-500뿨֮ûݴ䡣MUR-50016 0--15,
**          ΪԿšÿԿAԿBܹ32 롣װسɹ󣬿øԿMifare1 ֤
**          M1Ҳ16洢ΪšҪıMifare1 ڵԿԭ֤ͨ
**          ֱдTX_Write_Enc()дMifareĳʼԿΪ6FFHABԿһ
**
** 䡡:  modeԿ͡ȡֵΪmode0x00KEYA-ԿAmode0x04KEYB-ԿB
**		    secnrMUR-500ڵԿţȡֵΧ015
**			keyҪװصԿ6ֽʮ, Ӧ12ַ
**                
** 䡡:  
**
** : μֵб
** 
**   :  TX2_Load_Key(0x00, 0x01, "112233445566")
********************************************************************************************************/
UINT __stdcall TX2_Load_Key(UINT mode, UINT secnr, char *key);


/*********************************************************************************************************
**   :  TXģЧΧǷпڡѡһµĿʱøú
**           ƬܻӶõ縴λIDLEģ飬TX_Request
**           ALLIDLEһģʽ󣬿ƬӦؿƬͺTagType2ֽڣ
**           ĳһſɹ˹TX_HaltƬHalt״̬ʱĿֻ
**           ӦALLģʽ󣬳Ǹÿ뿪Ȼ½롣
**           TXģ鷢0x41󿨡
**           ע⣺ͬһſHALT״̬ʱһγɹһʧ
**
** 䡡: modeģʽ ReqCodeȡֵΪ10 
**         mode0IDLE߷ΧIDLE״̬ĿHALT״̬ĳ⣩
**         mode1ALL߷Χڵп
**
**
** 䡡: TagTypeƬ
**
**                +----+----+----+----+----+----+----+----+       +----+----+----+----+----+----+----+----+
**        MSByte  | b7 | b6 | b5 | b4 | b3 | b2 | b1 | b0 |LSByte | b7 | b6 | b5 | b4 | b3 | b2 | b1 | b0 |
**                +----+----+----+----+----+----+----+----+       +----+----+----+----+----+----+----+----+
**                |                 RFU                   |       |                                       | 
**                                                                | UID size| RFU|   bit-frame anticoll   |
**                                                                |         |    |                        |
**                                                                | 00..std |    |  (if any bit set .. Y, | 
**                                                                | 01..dbl |    |             else .. N) |
**                                                                | 10..tpl |    |                        |
**Mifare 1 S50    |                 RFU                   |       |  0   0    0    0  | 0    1    0    0  |  = 0x0004   UID(Ψһкţ4ֽ ֡ͻʽ
**Mifare 1 S70    |                 RFU                   |       |  0   0    0    0  | 0    0    1    0  |  = 0x0002   UID(Ψһкţ4ֽ ֡ͻʽ
**Mifare UltraLight|                RFU                   |       |  0   1    0    0  | 0    1    0    0  |  = 0x0044   UID(Ψһкţ7ֽ ֡ͻʽײ
**Mifare Light    |                 RFU                   |       |  0   0    0    1  | 0    0    0    0  |  = 0x0010   UID(Ψһкţ4ֽ ֡ͻʽ
**SHC1101         |                 RFU                   |       |  0   0    0    0  | 0    1    0    0  |  = 0x0004   UID(Ψһкţ4ֽ ֡ͻʽ
**SHC1102         | 0    0    1    1  |  0    0    1    1 |       |  0   0    0    0  | 0    0    0    0  |  = 0x3300   UID(Ψһкţ4ֽ Ǳ֡ͻʽ               
**11RF32          |                 RFU                   |       |  0   0    0    0  | 0    1    0    0  |  = 0x0004   UID(Ψһкţ4ֽ ֡ͻʽ
**
** : μֵб
**
********************************************************************************************************/
UINT __stdcall TX2_Request(UINT mode, UINT *tagtype);


/*********************************************************************************************************
** : ѡķײúڵTX_RequestáƬλʱ
**           ִкܵõкǸƬке4ֽڡ
**           кų֣4ֽڡ7ֽں10ֽڡ4ֽڵֻҪһײɵõкţ
**           Mifare1 S50 S70ȣ7ֽڵҪжײܵõкţǰһõкŵ
**           ֽΪ־0x88кֻ3ֽڿãһײܵõ4ֽкţ߰˳
**           ӼΪ7ֽкţUltraLightDesFireȣ10ֽڵԴƣûд࿨
**           Ҫжײͨ޸ĲSelect_Codeʵ֡һʹSelect_Code0x93
**           ڶʹSelect_Code0x95,еMifareҪײΪMifareк
**           Ϊ7ֽڡ֪Ҫѡ񿨵кź󣬾ûбҪִиTX_AntiCollʱTX_Request
**           ֱӵTX_Selectɡ
**           
** 䡡:  codeײ㼶룺һ㣨ANTICOLL1-0x93㣨ANTICOLL2-0x95㣨ANTICOLL3-0x97
**          bcntԤѡѾ֪кŵĵλͨBcnt=0
**      
** 䡡:  snrкšкų4ֽڣMifare UltraLightкŲֽڵֵΪ0x88
**               ʾҪиһķײTX2_Casc_Anticoll0x95
**
** : μֵб
**
********************************************************************************************************/
UINT __stdcall TX2_Casc_Anticoll(UINT bcnt, UINT code, ULONG *snr);

/*********************************************************************************************************
** : úѡĳһкŵĿ֮ͨӣǷѡɹӦ*Sak
**           úһTX_Casc_Anticoll()ʹãж༶ײ󿨵ѡ
**           Select_CodeʾײļӦúִǰTX_Casc_Anticoll()еSelect_Codeͬ.
**           һײɹִк󣬻κʱ򵱳Աʵʵ֪кŵĿƬͨʱ
**           ʹTX_Casc_SelectTX_SelectԽѡͨš
**           кų֣4ֽڡ7ֽں10ֽڡ4ֽڵֻҪһѡ񼴿,Mifare1 S50 S70ȣ
**           7ֽڵҪöѡɣUltraLightDesFireȡҪжѡ񣬵һѡ
**           кΪһײõк,ֽΪ־0x88ֻ3ֽڿãڶѡ
**           кΪڶײõ4ֽкš
**           ڳп*Sakbit2λжǷкδif(*SAK & 0x04){}
**
** 䡡:  codeײ㼶룺һ㣨ANTICOLL1-0x93㣨ANTICOLL2-0x95㣨ANTICOLL3-0x97
**                òӦ֮ǰTX2_Casc_Anticoll()еSelect_Codeͬ
**          snrǰһηײصĿţ֪ĿкšźŴ4ֽڣ
**               snrֵֽΪ0x88ʾҪиһķײ
** 䡡:  sakǷѡɹӦ,£
**
**                +----+----+----+----+----+----+----+----+
**       *Sak     | b7 | b6 | b5 | b4 | b3 | b2 | b1 | b0 |
**                +----+----+----+----+----+----+----+----+
**                |   RFU   |diff|   RFU   | ok |   RFU   | 
**Mifare 1 S50    |  0   0    0    0  |  1    0    0   0  |  = 0x08   
**Mifare 1 S70    |  0   0    0    1  |  1    0    0   0  |  = 0x18 
**Mifare UltraLight| 0   0    0    0  |  0    1    0   0  |  = 0x04 1ѡ
**Mifare Light    |  0   0    0    0  |  0    0    0   1  |  = 0x01 
**SHC1101         |  0   0    1    0  |  0    0    1   0  |  = 0x22 
**11RF32          |  0   0    0    0  |  1    0    0   0  |  = 0x08 
**
** bit2λжǷкδbit20ʱʾкϣѡɹ
** bit21ʱʾкûȫ룬ѡûȫɹҪһķײѡ
**	xxxxx1xx: źûɣҪһķײѡ
**	xx1xx0xx: ѡɹÿISO/IEC 14443-4׼
**	xx0xx0xx: ѡɹÿISO/IEC 14443-4׼
**
** : μֵб
**
*********************************************************************************************************/
UINT __stdcall TX2_Casc_Select(UINT code,unsigned long snr, UINT *sak);

/*********************************************************************************************************
** : ʹMUR-500ڲԿkeynrеָĿsecnr֤secnrе
**           洢MUR-500secnrе֤ͬɹOK
**           úTX2_Load_KeyɹִйΪMUR-500ڲkeynrеҪTX2_Load_Key
**           װءúڶп˵ͬӦãԿװؿһȫĳһװ롣

**
** 䡡:   modeԿͣ1ֽڣȡֵΪmode0x00KEYAԿA֤; mode0x04KEYBԿB֤
**           secnrҪ֤ĿţҲҪʵĿţȡֵΧ039S70
**           keynrMUR-500ڵԿţȡֵΧ015
**
** 䡡: 
**
** : μֵб
********************************************************************************************************/
UINT __stdcall TX2_Auth2(UINT mode,UINT secnr,UINT keynr);



/*********************************************************************************************************
** : TX2_Auth2ҪTX2_Load_Key()ĳɹִУڽ֤ʵ֮ǰһҪȷȷԿ
**           ѾMUR-500ԿڡTX2_Auth_KeyֱӽԿ͵MURڶԿƬ֤TX2_Auth_Key
**           ִʱԿвҲΪֱ֤ʵеԿƥ䣬֤ʵɹOK
**           ֱ֤ʵһڶÿһſ˵ԿͬӦãʹðȫģ飨PSAMӦУ
**           ѻȽкŶȻPSAMԿһɵԿȻֱõԿ뿨һӦ໥֤ʵ
**
** 䡡:   modeԿ͡ȡֵΪmode0x00KEYAԿA֤mode0x04KEYBԿB֤
**           key֤ʵ루6ֽʮݣӦ12ַ
**           secnrҪ֤ĿţҲҪʵĿţȡֵΧ039S70
**
** 䡡: 
**
** : μֵб
**
**   :  TX2_Auth_Key(0x00, "112233445566", 1)
********************************************************************************************************/
UINT __stdcall TX2_Auth_Key(UINT mode, char *key,UINT secnr);



/*********************************************************************************************************
** : ֤ɹʹøúMifareӦݡMifareһ16ֽڣ˶д
**           һξ16ֽڡű֮ǰ֤Ŀͬһڣmifare1ӿ0ʼ˳
**           ÿ41
**           ΪMifareÿܲͬҪһſеĶвڶĳһ
**           Ϻ󣬱һܶһֱӽ֤ʼ
**           ݲܱȡ                   
**
** 䡡: addrţ	S50063S700255
**
** 䡡: dataΪݵ׵ַصΪ16ֽڵʮݣӦ32ַȡ"00112233445566778899AABBCCDDEEFF"
**
** : μֵб
********************************************************************************************************/
UINT __stdcall TX2_Read_Enc(UINT addr, char *data);


/*********************************************************************************************************
** :ĳһֵ顣
**
** 䡡:  addr --ţ			S501~63
									S701~255
**                
** 䡡:  value4ֵֵֽ
**
** : μֵб
**           
********************************************************************************************************/
UINT __stdcall TX2_Read_Val(UINT addr, unsigned long *value);


/*********************************************************************************************************
** : Կĳһ֤ɹ󣬼ɶͬһĸдֻҪ
**           аλβ飬ǸΨһ                   
**
** 䡡: addrţ	S50163S701255  0鲻д
**         dataҪдݣ16ֽڵʮݣӦ32ַ
**
** 䡡: 
**
** : μֵб
**
     : TX2_Write_Enc(1, "00112233445566778899AABBCCDDEEFF")
********************************************************************************************************/
UINT __stdcall TX2_Write_Enc(UINT addr, char *data);




/*********************************************************************************************************
** : UltraLightдһ4ֽڵݡֻUltraLightЧUltraLightжmifare1һ                   
**           
** 䡡: addrţ	015
           dataҪдݣ4ֽڵʮݣӦ8ַ
**
** 䡡: 
**
** : μֵб
**   : TX2_ULwrite_Enc(1, "11223344")
*********************************************************************************************************/
UINT __stdcall TX2_ULwrite_Enc(UINT addr, char* data);


/*********************************************************************************************************
** : MifareӦдֵʽݡ
**
** 䡡: addr --ţ		        S501~63
**									    S701~255
**         value4ֽݣ洢ֵֵлָʱֵΪֵ
**                
** 䡡:  ޡ
**
** : μֵб
**           
********************************************************************************************************/
UINT __stdcall TX2_Write_Val(UINT addr,long value);



/*********************************************************************************************************
** : ˺ԿڵĳһмӡݱݣÿΪֵʽ봫ͬ
**           򽫲ĽдԭĿڣ봫Ųͬ򽫲Ľд봫ڣ
**           ԭڵֵ䡣ģʽΪ"ָ"ʱ"ֵ"塣     
**  
** 䡡: mode0xC0- 0xC1-ӣ 0xC2-ָ
**         addrڿַԸÿֵҲԴַȡֵΧS50163S701255
**         value4ֽݣ洢ֵֵлָʱֵΪֵ
**         trans_addrַҲǽַȡֵΧS50163S701255
**
**
** 䡡: 
**
** : μֵб
**
********************************************************************************************************/
UINT __stdcall TX2_Value(UINT mode,UINT addr,long value,UINT trans_addr);



/*********************************************************************************************************
** : ѡΪ״̬ҪѡӦALLģʽTX_Request
**           Ҫѡ,ҲԽ뿪߲ٽ룬ִиλTX_Reset()
**           ʹTX_Request()TX_Halt()һԿ۷ѣ翨ӦֻһΣһԪǮ
**           뿪´νٿһΣڸӦͣʱϳҲ۶һΡ
**
** 䡡: 
**
** 䡡: 
**
** : μֵб
**
********************************************************************************************************/
UINT __stdcall TX2_Halt(void);


/*********************************************************************************************************
** : ˺̵Ϩ
**  
** 䡡:  
**
** 䡡: 
**
** : μֵб
**
********************************************************************************************************/
UINT __stdcall TX2_Green_Off();

/*********************************************************************************************************
** : ˺̵
**  
** 䡡:  
**
** 䡡: 
**
** : μֵб
**
********************************************************************************************************/
UINT __stdcall TX2_Green_On();


/*********************************************************************************************************
** : ˺һ̵ƣƵʡʱ䡢϶ʱظ趨
**
** 䡡: Control:	 ֣Control = 0x01ʱƶΪControl = 0x02ʱƶΪ̵ƣ
           Control = 0x03ʱ̵ƺͷͬʱơ 
**             
**         OpenTime:	 ʱ䣬ȡֵ025510msķֱ
**         CloseTime:	 ϶ʱ䣬ȡֵ025510msķֱ
**         RepCnt:	 ظ
**
** 䡡: 
**
** : μֵб
**
*******************************************************************************************************/
UINT __stdcall TX2_Alarm(UINT contrl,UINT opentm,UINT closetm,UINT repcnt);




/***************************************************************************/
/***************************************************************************/


///////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
   }
#endif

#endif  